=== tests/lcitool/libvirt-ci/requirements.txt ===
PyYAML
requests
