=== roms/u-boot/board/atmel/sama5d2_icp/Makefile ===
# SPDX-License-Identifier:     GPL-2.0+
#
# Copyright (C) 2018 Microchip Technology Inc.
#                   Eugen Hristev <eugen.hristev@microchip.com>
#

obj-y += sama5d2_icp.o
