=== roms/u-boot/board/spear/spear310/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# (C) Copyright 2000-2004
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.

obj-y	:= spear310.o
