=== roms/u-boot/board/xes/common/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# (C) Copyright 2006
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.

obj-$(CONFIG_FSL_PCI_INIT)	+= fsl_8xxx_pci.o
obj-$(CONFIG_ARCH_MPC8572)		+= fsl_8xxx_clk.o
obj-$(CONFIG_MPC86xx)		+= fsl_8xxx_clk.o
obj-$(CONFIG_ARCH_P2020)		+= fsl_8xxx_clk.o
obj-$(CONFIG_MPC85xx)		+= fsl_8xxx_misc.o board.o
obj-$(CONFIG_MPC86xx)		+= fsl_8xxx_misc.o board.o
obj-$(CONFIG_NAND_ACTL)	+= actl_nand.o
