=== roms/u-boot/drivers/phy/allwinner/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# Copyright (C) 2016 Amarula Solutions
#

obj-$(CONFIG_PHY_SUN4I_USB)		+= phy-sun4i-usb.o
