=== roms/u-boot/drivers/power/fuel_gauge/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# Copyright (C) 2012 Samsung Electronics
# Lukasz Majewski <l.majewski@samsung.com>

obj-$(CONFIG_POWER_FG_MAX17042) += fg_max17042.o
